## Provisioning Botkit
As Botkit adds more platforms, it becomes increasingly difficult to keep track of all the methods for provisioning your bot on the various platforms we support. 

To help Botkit developers, we are pulling out detailed provisioning documents for each platform and keeping them in this directory. Our hope is that this will make our docs more flexible to platform changes, and clearly show the fastest way to stand up your bot!

## Platforms

#### [Slack (Events API)](slack-events-api.md)

#### [Facebook Messenger](facebook_messenger.md)

#### [Cisco Spark](cisco-spark.md)

#### [SMS from Twilio](twilio-sms.md)


## Documentation

* [Get Started](../../readme.md)
* [Botkit Studio API](../readme-studio.md)
* [Function index](../readme.md#developing-with-botkit)
* [Extending Botkit with Plugins and Middleware](../middleware.md)
  * [List of current plugins](../readme-middlewares.md)
* [Storing Information](../storage.md)
* [Logging](../logging.md)
* Platforms
  * [Slack](../readme-slack.md)
  * [Cisco Spark](../readme-ciscospark.md)
  * [Facebook Messenger](../readme-facebook.md)
  * [Twilio SMS](https://../readme-twiliosms.md)
  * [Twilio IPM](https://../readme-twilioipm.md)
  * [Microsoft Bot Framework](../readme-botframework.md)
* Contributing to Botkit
  * [Contributing to Botkit Core](../../CONTRIBUTING.md)
  * [Building Middleware/plugins](../howto/build_middleware.md)
  * [Building platform connectors](../howto/build_connector.md)
