# Botkit Starter Kits

## [Botkit Anywhere](https://github.com/howdyai/botkit-starter-web)

Build a bot for the web and embed it in your site or native application.

## [Slack Starter Kit](https://github.com/howdyai/botkit-starter-slack)

Everything you need to build a Slack application or custom internal integration

## [Microsoft Teams Starter Kit](https://github.com/howdyai/botkit-starter-teams)

Everything you need to build a bot, compose extension or tab for Microsoft Teams

## [Cisco Spark Starter Kit](https://github.com/howdyai/botkit-starter-ciscospark)

Everything you need to build a custom bot for Cisco Spark

## Documentation

* [Get Started](readme.md)
* [Botkit Studio API](readme-studio.md)
* [Function index](readme.md#developing-with-botkit)
* [Starter Kits](readme-starterkits.md)
* [Extending Botkit with Plugins and Middleware](middleware.md)
  * [Message Pipeline](readme-pipeline.md)
  * [List of current plugins](readme-middlewares.md)
* [Storing Information](storage.md)
* [Logging](logging.md)
* Platforms
  * [Web and Apps](readme-web.md)
  * [Slack](readme-slack.md)
  * [Cisco Spark](readme-ciscospark.md)
  * [Microsoft Teams](readme-teams.md)
  * [Facebook Messenger](readme-facebook.md)
  * [Twilio SMS](readme-twiliosms.md)
  * [Twilio IPM](readme-twilioipm.md)
  * [Microsoft Bot Framework](readme-botframework.md)
* Contributing to Botkit
  * [Contributing to Botkit Core](../CONTRIBUTING.md)
  * [Building Middleware/plugins](howto/build_middleware.md)
  * [Building platform connectors](howto/build_connector.md)
